/**
 * Created by Haider on 9/9/2015.
 */
    var timer = null;
var GridSelector = function () {
    var self = this;
    this.gridWidth = 0;
    this.bTouchStart = false;
    this.load = function(index){
        var data = window.localStorage.getItem("net"+index);
        if(data!=null){
            var obj = JSON.parse(data);
            for (var key in obj ) {
                if (obj .hasOwnProperty(key)) {
                    $("#"+index+"_"+key).find('p').text(obj[key]);
                    //_this.filledCell[key] = obj[key];
                }
            }
        }
    }
    this.init = function (winWidth, winHeight) {

        this.gridWidth = winWidth > winHeight ? winHeight : winWidth;
        //if (this.gridWidth >= 600)
        //    this.gridWidth = 500;
        if (winWidth <= 320)
            this.gridWidth = 200;
        else
            this.gridWidth = Math.floor(winWidth/1.2);
        var cellWidth = Math.floor(this.gridWidth / 10);
        this.gridWidth = cellWidth*10;
        $("#gridsContainer").css("width",((this.gridWidth + 10) * (netData.length+1))+"px");
        $("#gridsContainer").css("height",this.gridWidth+"px");
        $(".gridSelectDiv").css("height",(this.gridWidth+5)+"px");
        var unlockedNet = window.localStorage.getItem("on").split(",");
        //console.log(unlockedNet+"-"+window.localStorage.getItem("on"));
        var lastNetSolved = window.localStorage.getItem("lno");
        var gridHTML = "";
        var classes = "";
        var row = 0;

        for (var i = 0; i < 10; i++) {
            var col = 9;

            for (var j = 0; j < 10; j++) {


                classes = "border-left-top ";
                if (i == 9)
                    classes += " border-bottom ";
                if (j == 9)
                    classes += " border-right ";
                var id = "";
                if (row < 10) {
                    /*if (_netData.data[row].content[col] == "")
                        classes += " dark-cell";
                    else*/
                        classes += " white-cell";
                    //id = _netData.id+"_"+row + "_" + col;
                    id = "g_"+row + "_" + col;
                    col--;
                }
                gridHTML +='<div id="' + id + '" style="width:' + cellWidth + 'px;height:' + cellWidth + 'px;" class="cell2 ' + classes + '"><p></p></div>';

            }
            row++;
        }
        netData.forEach(function (_netData) {

            var grid = $('<div id="net_'+_netData.id+'" class="grid2" style="background-image: url(img/net'+_netData.id+'.png);background-size: contain;"></div>');
            //var grid = $('<div id="net_'+_netData.id+'" class="grid2"></div>');
            grid.css("width",self.gridWidth+"px");
            grid.css("height",self.gridWidth+"px");
/*--            var idDiv = $('<div class="net-index-div">');

            var nId = (_netData.id+1)+"";
            if(nId.length==1){
                idDiv.css("background-image","url(img/net"+nId.charAt(0)+".png)");
                idDiv.css("background-position","center center");
            }else{
                idDiv.css("background-image","url(img/net"+nId.charAt(0)+".png),url(img/net"+nId.charAt(1)+".png)");
                idDiv.css("background-position","top left,top right");

            }
 grid.append(idDiv);
            */
            //console.log(_netData.id);
            //idDiv.append($('<img src="img/net'+nId.charAt(0)+'.png" height="100%" style="display:inline-block">'));
            //if(nId.length>1)
             //   idDiv.append($('<img src="img/net'+nId.charAt(1)+'.png" height="100%" style="display:inline-block">'));

            if(unlockedNet.indexOf(_netData.id+"")==-1){
                    grid.append('<div class="lock"></div>');
            }


/*--            var classes = "";
            var row = 0;

            for (var i = 0; i < 10; i++) {
                var col = 9;

                for (var j = 0; j < 10; j++) {


                    classes = "border-left-top ";
                    if (i == 9)
                        classes += " border-bottom ";
                    if (j == 9)
                        classes += " border-right ";
                    var id = "";
                    if (row < 10) {
                        if (_netData.data[row].content[col] == "")
                            classes += " dark-cell";
                        else
                            classes += " white-cell";
                        id = _netData.id+"_"+row + "_" + col;
                        col--;
                    }
                    grid.append('<div id="' + id + '" style="width:' + cellWidth + 'px;height:' + cellWidth + 'px;" class="cell2 ' + classes + '"><p></p></div>');

                }
                row++;
            }--*/
            grid.append(gridHTML);
            $("#gridsContainer").append(grid);
            self.load(_netData.id);
        });
        var more = $('<div id="null" class="grid2" style="background-image: url(img/morecomming.png);background-size: contain;vertical-align: top;"></div>');
        more.css("width",self.gridWidth+"px");
        more.css("height",self.gridWidth+"px");
        $("#gridsContainer").append(more);
        $(".grid2").bind("touchstart",function(e){
            self.bTouchStart = true;
        });
        $(".grid2").bind("touchmove",function(e){
            self.bTouchStart = false;
            console.log(e.target);
        });
        $(".grid2").bind("touchend",function(e) {
            if (self.bTouchStart) {
                if($(this).attr("id") == "null")
                    return;
                if($(this).find(".lock").length>0){
                    //$("#confirmClose").show();
                    $("#confirmYesNo").hide();
                    $("#confirmGotIt").show();
                    //$("#confirmCloseBtn").show();
                    $("#confirmYesNo").hide();
                    $("#confTitleLabel").removeClass();
                    $("#confTitleLabel").addClass("alert-title");
                    $("#contMsg").removeClass();
                    $("#contMsg").addClass("locked-msg");
                    $(".modal-div").css("z-index","101");
                    $(".modal-div").show();
                    $("#confirm_dialog").show();
                    playSound( 'error' );
                    return;
                }

                var netId = $(this).attr("id").split("_")[1];
                if((currentNet!=null && currentNet.index != netId) || currentNet==null) {
                    if(qData == null)
                        qData = JSON.parse(qDataStr);
                    currentNet = new Crossword(netId, netData[netId], qData[netId]);
                    currentNet.init(winWidth, winHeight);

                }
                localStorage.gp = $(".gridSelectDiv").scrollLeft();
                /*else{
                    currentNet.highlightCorrectAnswers();
                    $(".homeDiv").addClass("hide-on-right");
                    $(".gamePlayDiv").addClass("show");
                }*/

                $("#netId").attr("src","img/"+netId+".png");
                self.bTouchStart = false;
                $("#vertItems").scrollTop(0);
                $("#horzItems").scrollTop(0);
                setTimeout(function () {
                    $(".homeDiv").addClass("hide-on-right");
                    $(".gamePlayDiv").addClass("show");
                    $(".gamePlayDiv").one(
                        'webkitTransitionEnd',
                        function( event ) {
                            currentNet.highlightCorrectAnswers();
                            showQuesAndKBDiv(false);
                        });
                },0);
                /*setTimeout(function () {
                    $(".homeDiv").addClass("hide-on-right");
                    $(".gamePlayDiv").addClass("show");
                },0);*/



            }
        });
        $(".cell2").css("font-size",vw(4));
    };
}