/**
 * Created by Haider on 8/6/2015.
 */
var HORZ = "h";
var VERT = "v";
var bTouchStart = false;
var Crossword = function (index,_netData, qData) {
    this.index = index;
    this.selectedId = "";
    this._netData = _netData;
    this.qData = qData;
    this.gridWidth = 0;
    //this.arNumber = ["&#x661", "&#x662", "&#x663", "&#x664", "&#x665", "&#x666", "&#x667", "&#x668", "&#x669", "&#x661&#x660",];
    var _this = this;
    this.curDir = HORZ;
    this.curQuestion = null;
    this.curQuestionData = null;
    this.filledCell = {};
    this.save = function(){
        window.localStorage.setItem("net"+_this.index, JSON.stringify(_this.filledCell));

    };
    this.load = function(){
        var data = window.localStorage.getItem("net"+_this.index);
        if(data!=null){
            var obj = JSON.parse(data);

            for (var key in obj ) {
                if (obj .hasOwnProperty(key)) {
                    $("#"+key).find('p').text(obj[key]);
                    _this.filledCell[key] = obj[key];
                }
            }

            this.highlightCorrectAnswers();
        }

    }
    this.highlightCorrectAnswers = function() {
        var unlockedNet = window.localStorage.getItem("on");
        var nHCorrect = 0;
        var nVCorrect = 0;
        var nCorrect = 0;
        _this.qData.data.Horizontal.forEach(function (data) {
            var cols = data.colno.split("-");
            var sCol = parseInt(cols[0]);
            var eCol = parseInt(cols[1]);
            var row = parseInt(data.rowno);
            var correct = true;
            for (var c = sCol; c <= eCol; c++) {
                var ch = $("#" + data.rowno + "_" + c).text();
                if (ch != _this._netData.data[row].content[c]) {
                    correct = false;
                    break;
                }
            }
            if(correct)
                nHCorrect++;
            if (correct) {
                if(window.localStorage.getItem("sc")!= 0) {
                    //if (!$("#h-" + data.rowno + "-" + data.colno).find(".gallery-contents").hasClass("correct-answer"))
                     //   nCorrect++;
                    $("#h-" + data.rowno + "-" + data.colno).find(".gallery-contents").addClass("correct-answer");
                    for (var c = sCol; c <= eCol; c++) {
                        $("#" + data.rowno + "_" + c).addClass("correct-answer-h");
                    }
                }
                if (!$("#h-" + data.rowno + "-" + data.colno).find(".gallery-contents").hasClass("correct-answer-flag"))
                    nCorrect++;
                $("#h-" + data.rowno + "-" + data.colno).find(".gallery-contents").addClass("correct-answer-flag");

            }
            else {
                for (var c = sCol; c <= eCol; c++) {
                    $("#" + data.rowno + "_" + c).removeClass("correct-answer-h");
                }
                $("#h-" + data.rowno + "-" + data.colno).find(".gallery-contents").removeClass("correct-answer");
                $("#h-" + data.rowno + "-" + data.colno).find(".gallery-contents").removeClass("correct-answer-flag");
            }
        });
        _this.qData.data.Vertical.forEach(function(data){
            var rows = data.rowno.split("-");
            var sRow = parseInt(rows[0]);
            var eRow = parseInt(rows[1])
            var col = parseInt(data.colno);
            var correct=true;
            for (var i = sRow; i <= eRow; i++){
                var ch = $("#" + i + "_" + data.colno).text();
                if(ch != _this._netData.data[i].content[col]){
                    correct = false;
                    break;
                }
            }
            if(correct)
                nVCorrect++;
            if(correct) {
                if(window.localStorage.getItem("sc")!= 0) {
                    //if (!$("#v-" + data.colno + "-" + data.rowno).find(".gallery-contents").hasClass("correct-answer"))
                    //    nCorrect++;
                    for (var i = sRow; i <= eRow; i++) {
                        var ch = $("#" + i + "_" + data.colno).addClass("correct-answer-v");
                    }
                    $("#v-" + data.colno + "-" + data.rowno).find(".gallery-contents").addClass("correct-answer");
                }
                if (!$("#v-" + data.colno + "-" + data.rowno).find(".gallery-contents").hasClass("correct-answer-flag"))
                    nCorrect++;
                $("#v-" + data.colno + "-" + data.rowno).find(".gallery-contents").addClass("correct-answer-flag");

            }
            else {
                for (var i = sRow; i <= eRow; i++) {
                    var ch = $("#" + i + "_" + data.colno).removeClass("correct-answer-v");
                }
                $("#v-" + data.colno + "-" + data.rowno).find(".gallery-contents").removeClass("correct-answer");
                $("#v-" + data.colno + "-" + data.rowno).find(".gallery-contents").removeClass("correct-answer-flag");
            }
        });
        var id = parseInt(_this.index);
        //if(unlockedNet.indexOf((_this.index+1)+"")==-1)


        if($("#horzItems").find(".gallery-contents").length == $("#horzItems").find(".correct-answer-flag").length &&
            $("#vertItems").find(".gallery-contents").length == $("#vertItems").find(".correct-answer-flag").length){
            $(".inGamePic").hide();
            $("#confirmGotIt").show();
            $("#confirmYesNo").hide();
            $("#confirmYesNo").hide();
            $("#confTitleLabel").removeClass();
            $("#confTitleLabel").addClass("alert-title");
            $("#contMsg").removeClass();
            $("#contMsg").addClass("all-solved-msg");
            $(".modal-div").css("z-index","101");
            $(".modal-div").show();
            $("#confirm_dialog").show();
            setTimeout(function(){playSound( 'gameend' );},1000);

        }else
            if(id<(netData.length-1) && $("#net_"+(id+1)).find(".lock").length>0){
                if((nHCorrect+nVCorrect)>9){
                    playSound( 'unlock' );
                    $("#net_"+(id+1)).find(".lock").remove();
                    unlockedNet = unlockedNet + ","+(id+1);
                    window.localStorage.setItem("on",unlockedNet);
                    $(".msg").addClass("show-msg");
                    setTimeout(function(){
                        $(".msg").removeClass("show-msg");
                    },3000);
                }else
                if(nCorrect>0)
                    playSound( 'correct' );
            }else {
                if(id==(netData.length-1) && (nHCorrect+nVCorrect)>9 && window.localStorage.getItem("lno")==0)
                    window.localStorage.setItem("lno","1");
                if (nCorrect > 0)
                    playSound('correct');
            }
    }
    this.init = function(){
        var data = window.localStorage.getItem("net"+_this.index);
        if(data!=null) {
            var obj = JSON.parse(data);
            for (var key in obj) {
                if (obj.hasOwnProperty(key)) {
                    //$("#" + key).find('p').text(obj[key]);
                    _this.filledCell[key] = obj[key];
                }
            }
        }
        //$(".dark-cell").removeClass("dark-cell");
        $(".cell").removeClass("selected selected2 correct-answer-v correct-answer-h")
        $(".cell").find("p").text("");
        var classes = "";
        for (var row = 0; row < 10; row++) {
            for (var col = 0; col < 10; col++) {
                var id = row + "_" + col;
                if (this._netData.data[row].content[col] == ""){
                    $("#"+id).removeClass("white-cell");
                    $("#"+id).addClass("dark-cell");
                }
                else
                {
                    $("#"+id).removeClass("dark-cell");
                    $("#"+id).addClass("white-cell");
                }




                    var ch = "";
                    //if(bDontLoad==null)
                    ch = _this.filledCell[id]==null?"":_this.filledCell[id];
                $("#"+id).find("p").text(ch) ;
            }
        }

        this.initQuestionList();


    };
    this.initQuestionList = function(){
        $("#horzItems").empty();
        $("#vertItems").empty();
        //add question to qListDiv
        _this.qData.data.Horizontal.forEach(function(obj){
            var n = obj.index < 10 ? String.fromCharCode(0x660 + obj.index) : String.fromCharCode(0x661) + String.fromCharCode(0x660);
            var item = $('<li class="gallery-item" id="h-'+obj.rowno+"-"+obj.colno+'"><div class="gallery-contents"> <div class="thumbnail gallery-trigger" ><span>'+n+"-"+obj.content+'</span></div></div></li>');
            item.data("qData",obj);
            $("#horzItems").append(item);
        });
        _this.qData.data.Vertical.forEach(function(obj){
            var n = obj.index < 10 ? String.fromCharCode(0x660 + obj.index) : String.fromCharCode(0x661) + String.fromCharCode(0x660);
            var item = $('<li class="gallery-item" id="v-'+obj.colno+"-"+obj.rowno+'"><div class="gallery-contents"> <div class="thumbnail gallery-trigger" ><span>'+n+"-"+obj.content+'</span></div></div></li>');
            item.data("qData",obj);
            $("#vertItems").append(item);
        });
        $(".gallery-item").bind("touchstart",function(e){
            bTouchStart = true;
        });
        $(".gallery-item").bind("touchmove",function(e){
            bTouchStart = false;
        });
        $(".gallery-item").bind("touchend",function(e) {
            if (bTouchStart) {
                playSound( 'select' );
                var ele = $(this);
                if(!ele.hasClass("highlited"))
                    $(".highlited").removeClass("highlited");
                ele.addClass("highlited");
                var id = ele.attr("id").split("-");
                var data = ele.data("qData")
                $(".selected2").removeClass("selected2");
                if(id[0]=="h"){
                    _this.curDir = HORZ;
                    _this.highlightCells(data, HORZ);
                    _this.curQuestion = data;
                    _this.showQuestion(data.rowno, _this.curQuestion.content, HORZ);
                    if (data.content.indexOf("(م)") > -1) {
                        $("#" + data.rowno + "_" + id[3]).addClass("selected2");
                        _this.selectedId = data.rowno + "_" + id[3];
                    }
                    else {
                        $("#" + data.rowno + "_" + id[2]).addClass("selected2");
                        _this.selectedId = data.rowno + "_" + id[2];
                    }

                    //$("#qListDiv").slideUp();
                    showQuesAndKBDiv(true);
                    //$("#qAndKbDiv").show();
                }else
                if(id[0]=="v") {
                    _this.curDir = VERT;
                    _this.highlightCells(data, VERT);
                    _this.curQuestion = data;
                    _this.showQuestion(data.colno,_this.curQuestion.content,VERT);
                    if (data.content.indexOf("(م)") > -1) {
                        $("#" + id[3] + "_" + data.colno).addClass("selected2");
                        _this.selectedId = id[3] + "_" + data.colno;
                    }
                    else {
                        $("#" + id[2] + "_" + data.colno).addClass("selected2");
                        _this.selectedId = id[2] + "_" + data.colno;
                    }
                    //$("#qListDiv").slideUp();
                    showQuesAndKBDiv(true);
                    //$("#qAndKbDiv").show();
                }

            }
        });

        $(".gallery-item").css("font-size",vw(4));
        $(".gallery-item").css("line-height",vw(5));

    };
  /* this.init = function (winWidth, winHeight, bDontLoad) {
       // _this = this;
        var data = window.localStorage.getItem("net"+_this.index);
        if(data!=null) {
            var obj = JSON.parse(data);
            for (var key in obj) {
                if (obj.hasOwnProperty(key)) {
                    //$("#" + key).find('p').text(obj[key]);
                    _this.filledCell[key] = obj[key];
                }
            }
        }
        this.gridWidth = winWidth > winHeight ? winHeight : winWidth;
        if (this.gridWidth > 600)
            this.gridWidth = 600;
        if (winWidth <= 320)
            this.gridWidth = 275;
        $(".grid").width(this.gridWidth);
        $(".grid").height(this.gridWidth);
        var leftMargin = 0;
        if(winWidth == this.gridWidth)
            leftMargin = 10;
        if (winWidth > winHeight)
            $(".grid").css("left", (winWidth - this.gridWidth) + "px")
        else
            $(".grid").css("left", ((winWidth / 2 - this.gridWidth / 2)+leftMargin) + "px")
        var cellWidth = Math.floor(this.gridWidth / 11);
        $('.cell').remove();
        $('.number').remove();
        var classes = "";
        var row = 0;

        for (var i = 0; i < 11; i++) {
            var col = 9;
            for (var j = 0; j < 11; j++) {

                if ((i == 0 )) {
                    var n = "&nbsp";
                    if (j < 10)
                        n = this.arNumber[9 - j];
                    $('.grid').append('<div style="width:' + cellWidth + 'px;height:' + cellWidth / 2 + 'px;" class="number">' + n + '</div>');
                } else if (i > 0 && j == 10) {
                    $('.grid').append('<div style="width:' + cellWidth + 'px;height:' + cellWidth + 'px;line-height:' + cellWidth + 'px" class="number">' + this.arNumber[i - 1] + '</div>');
                    row++;
                }
                else if (j < 10) {
                    classes = "border-left-top ";
                    if (i == 10)
                        classes += " border-bottom ";
                    if (j == 9)
                        classes += " border-right ";
                    var id = "";
                    if (row < 10) {
                        if (this.netData.data[row].content[col] == "")
                            classes += " dark-cell";
                        else
                            classes += " white-cell";
                        id = row + "_" + col;
                        col--;
                    }
                    var ch = "";
                    //if(bDontLoad==null)
                    ch = _this.filledCell[id]==null?"":_this.filledCell[id];
                    $('.grid').append('<div id="' + id + '" style="width:' + cellWidth + 'px;height:' + cellWidth + 'px;" class="cell ' + classes + '"><p>'+ch+'</p></div>');
                }
            }
        }
        $(".cell").bind("touchstart", this.onCellTapped);

        _this.initQuestionList();
        if(bDontLoad==null)
            _this.highlightCorrectAnswers();
        //$("#qListDiv").slideDown();
        showQuesAndKBDiv(false);
    };
    this.onCellTapped = function () {


        var cell = $(this);
        if (cell.hasClass("dark-cell"))
            return;
        if(cell.hasClass("selected2"))
            playSound( 'select2' );
        else
        if(!cell.hasClass("selected"))
            playSound( 'select' );
        var rowCol = cell.attr("id").split("_");
        var rowNo = parseInt(rowCol[0]);
        var colNo = parseInt(rowCol[1]);
        var qData = _this.qData;
        if (cell.hasClass("selected2"))
            _this.curDir = _this.curDir == HORZ ? VERT : HORZ;
        else {
            $(".selected2").removeClass("selected2");
        }
        $(".selected").removeClass("selected");
        if (_this.curDir == HORZ) {
            var data = _this.getQuestionFormRowCol(rowNo, colNo, HORZ);
            if(data!=null) {
                _this.highlightCells(data, HORZ);
                _this.curQuestion = data;
                _this.showQuestion(rowNo, _this.curQuestion.content, HORZ);
            }else{
                var data = _this.getQuestionFormRowCol(rowNo, colNo, VERT);
                if(data!=null){
                    _this.curDir = VERT;
                    _this.highlightCells(data, VERT);
                    _this.curQuestion = data;
                    _this.showQuestion(colNo,_this.curQuestion.content,VERT);
                }
            }
        } else {
            var data = _this.getQuestionFormRowCol(rowNo, colNo, VERT);
            if(data!=null) {
                _this.highlightCells(data, VERT);
                _this.curQuestion = data;
                _this.showQuestion(colNo, _this.curQuestion.content,VERT);
            }else{
                var data = _this.getQuestionFormRowCol(rowNo, colNo, HORZ);
                if(data!=null) {
                    _this.curDir = HORZ;
                    _this.highlightCells(data, HORZ);
                    _this.curQuestion = data;
                    _this.showQuestion(rowNo, _this.curQuestion.content, HORZ);

                }
            }
        }



        cell.addClass("selected2");
        //$("#qListDiv").slideUp();
        showQuesAndKBDiv(true);
        //$("#qAndKbDiv").show();
    }*/

    this.getQuestionFormRowCol = function (rowNo, colNo, dir) {
        if (dir == HORZ) {
            for (var d = 0; d < _this.qData.data.Horizontal.length; d++) {
                var data = qData.data.Horizontal[d];
                var cols = data.colno.split("-");
                var sCol = parseInt(cols[0]);
                var eCol = parseInt(cols[1]);


                if (parseInt(data.rowno) == rowNo && colNo >= sCol && colNo <= eCol) {
                    return data;
                }
            }
        } else {
            for (var d = 0; d < _this.qData.data.Vertical.length; d++) {
                var data = qData.data.Vertical[d];
                var rows = data.rowno.split("-");
                var sRow = parseInt(rows[0]);
                var eRow = parseInt(rows[1]);

                if (parseInt(data.colno) == colNo && rowNo >= sRow && rowNo <= eRow) {
                    return data;
                }
            }
        }
        return null;
    }
    this.showQuestion = function(qNumber, content, dir){
        var index = parseInt(qNumber);
        var n = index < 9 ? String.fromCharCode(0x661 + index) : String.fromCharCode(0x661) + String.fromCharCode(0x660);
        var arrow = "";
        if(dir == HORZ){
            if (content.indexOf("(م)") > -1)
                arrow = "→";
            else
                arrow = "←";
        }else{
            if (content.indexOf("(م)") > -1)
                arrow = "↑";
            else
                arrow = "↓";
        }
        if (content.indexOf("(م)") > -1 && window.localStorage.getItem("hint")!="1"){
            //$("#confirmClose").hide();
            $("#confirmYesNo").hide();
            $("#confirmGotIt").show();
            $("#confTitleLabel").removeClass();
            $("#confTitleLabel").addClass("alert-title");
            $("#contMsg").removeClass();
            $("#contMsg").addClass("hint-msg");
            $(".modal-div").css("z-index","101");
            $(".modal-div").show();
            window.localStorage.setItem("hint","1");
            $("#confirm_dialog").show();
        }
        $(".question").text(n + " "+arrow + " "+ content );
    }
    this.checkAnswer = function(data,dir){
       // setTimeout(function(){
            _this.highlightCorrectAnswers();
        //},500);

/*        if(dir==HORZ){
            var cols = data.colno.split("-");
            var sCol = parseInt(cols[0]);
            var eCol = parseInt(cols[1]);
            var row = parseInt(data.rowno);
            var correct=true;
            for(var c=sCol;c<=eCol;c++){
                var ch = $("#" + data.rowno + "_" + c).text();
                if(ch != _this.netData.data[row].content[c]){
                    correct = false;
                    break;
                }
            }
            if(correct)
                $(".highlited").find(".gallery-contents").addClass("correct-answer");
            else
                $(".highlited").find(".gallery-contents").removeClass("correct-answer");
        }else{
            var rows = data.rowno.split("-");
            var sRow = parseInt(rows[0]);
            var eRow = parseInt(rows[1])
            var col = parseInt(data.colno);
            var correct=true;
            for (var i = sRow; i <= eRow; i++){
                var ch = $("#" + i + "_" + data.colno).text();
                if(ch != _this.netData.data[i].content[col]){
                    correct = false;
                    break;
                }
            }
            if(correct)
                $(".highlited").find(".gallery-contents").addClass("correct-answer");
            else
                $(".highlited").find(".gallery-contents").removeClass("correct-answer");
        }*/
    }
    this.highlightCells = function(data,dir){
        $(".selected").removeClass("selected");
        $(".highlited").removeClass("highlited");
        if(dir==HORZ) {
            var cols = data.colno.split("-");
            var sCol = parseInt(cols[0]);
            var eCol = parseInt(cols[1]);
            for (var i = sCol; i <= eCol; i++)
                $("#" + data.rowno + "_" + i).addClass("selected");
            $("#h-"+data.rowno+"-"+data.colno).addClass("highlited");
            if(data.img!=null){

                var firstCellPos = $("#" + data.rowno + "_" + sCol).offset();
                var lastCellPos = $("#" + data.rowno + "_" + eCol).offset();
                var cellWH = $("#" + data.rowno + "_" + sCol).outerWidth();
                var gridWH = $(".grid").outerWidth();

                var imgWH = 120;//$(".inGamePic").outerWidth();
                if(winWidth>=360)
                    imgWH = 150;
                if(winWidth>=600)
                    imgWH = 200;
                //$("#inGameImg").attr("src","img/game/1.jpg");//+data.img);
                //+data.img);
                var picX = firstCellPos.left+cellWH-imgWH;
                var picY = firstCellPos.top+cellWH+1;
                if(picX<0)
                    picX = 0;//lastCellPos.left+cellWH;
                if(picY+imgWH>gridWH+30) {
                    picY = firstCellPos.top - imgWH-2;
                    if(picY<0){
                        $(".inGamePic").width(imgWH+picY);
                        picY=0;
                    }

                }
                var hide = true;
                var curImg = $("#inGameImg").attr("src").split("/");
                if(curImg.indexOf(data.img)!=-1)
                    hide = false;
                hideInGamePic(function() {
                    $(".inGamePic").css("top", picY + "px");
                    $(".inGamePic").css("left", picX + "px");
                    $(".inGamePic").show();

                    //if(osVersion.indexOf("4.1")==0){
                    //    $("#inGameImg").attr("src", "img/game/" + data.img);
                   // }else {
                        var img = new Image();
                        img.src = "img/game/" + data.img;
                        img.onload = function () {
                            //$("#inGameImg").attr("src", "url('" + img.src + "')" );
                            $("#inGameImg").attr("src", img.src);//+data.img);
                            setTimeout(function () {
                                $("#inGameImg").addClass("show-inGamePic");//.show();

                                $("#inGameImg").one('webkitTransitionEnd', function () {
                                    setTimeout(function () {
                                        $("#closeInGamePic").show();
                                    }, 0);
                                });
                            }, 0);
                        }
                 //  }
                },hide);
                //$(".inGamePic").css("background-image","url(img/game/1.jpg)");
            }
            else
                hideInGamePic();
        }else{
            var rows = data.rowno.split("-");
            var sRow = parseInt(rows[0]);
            var eRow = parseInt(rows[1])
            for (var i = sRow; i <= eRow; i++)
                $("#" + i + "_" + data.colno).addClass("selected");
            $("#v-"+data.colno+"-"+data.rowno).addClass("highlited");
            if(data.img!=null){

                var firstCellPos = $("#" + sRow + "_" + data.colno).offset();
                var lastCellPos = $("#" + eRow + "_" + data.colno).offset();
                var cellWH = $("#" + sRow + "_" + data.colno).outerWidth();
                var gridWH = $(".grid").outerWidth();

                var imgWH = 120;//$(".inGamePic").outerWidth();
                if(winWidth>=360)
                    imgWH = 150;
                if(winWidth>=600)
                    imgWH = 200;
                var picX = firstCellPos.left-imgWH-4;
                var picY = firstCellPos.top;
                if(picX<0) {
                    picX = firstCellPos.left+cellWH+1;
                }
                if(picY+imgWH>gridWH+30) {
                    picY = (gridWH+30) - imgWH;
                    if(picY<0)
                        picY=0;
                }
                var hide = true;
                var curImg = $("#inGameImg").attr("src").split("/");
                if(curImg.indexOf(data.img)!=-1)
                    hide = false;
                hideInGamePic(function(){
                    $(".inGamePic").css("top",picY+"px");
                    $(".inGamePic").css("left",picX+"px");
                    $(".inGamePic").show();
                    var img = new Image();
                    img.src = "img/game/"+data.img;

                    img.onload = function( ) {
                        //$("#inGameImg").attr("src", "url('" + img.src + "')" );
                        $("#inGameImg").attr("src",img.src);//+data.img);
                        setTimeout(function(){
                            $("#inGameImg").addClass("show-inGamePic");//.show();

                            $("#inGameImg").one('webkitTransitionEnd', function(){
                                setTimeout(function() {
                                    $("#closeInGamePic").show();
                                },0);
                            });
                        },0);
                    }
                },hide);

                //$(".inGamePic").css("background-image","url(img/game/1.jpg)");
            }
            else
                hideInGamePic();
        }
    }
}